Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/AGE/trcsms_age.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/AGE/trcsms_age.F90	(revision 8441)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/AGE/trcsms_age.F90	(revision 8442)
@@ -57,7 +57,9 @@
       IF( nn_timing == 1 )  CALL timing_start('trc_sms_age')
       !
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) ' trc_sms_age:  AGE model'
-      IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+      IF( kt == nittrc000 ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) ' trc_sms_age:  AGE model'
+         IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+      ENDIF
 
       IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj, jpk, ztrage )
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/C14b/trcnam_c14b.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/C14b/trcnam_c14b.F90	(revision 8441)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/C14b/trcnam_c14b.F90	(revision 8442)
@@ -49,9 +49,6 @@
       ! definition of additional diagnostic as a structure
       INTEGER :: jl, jn
-      TYPE(DIAG), DIMENSION(jp_c14b_2d) :: c14dia2d
-      TYPE(DIAG), DIMENSION(jp_c14b_3d) :: c14dia3d
       !!
       NAMELIST/namc14date/ ndate_beg_b, nyear_res_b
-      NAMELIST/namc14dia/  c14dia2d, c14dia3d     ! additional diagnostics
       !!-------------------------------------------------------------------
       !                             ! Open namelist file
@@ -77,50 +74,4 @@
       IF(lwp) WRITE(numout,*) '    initial year (aa)                  nyear_beg_b = ', nyear_beg_b
       !
-      IF( .NOT.lk_iomput .AND. ln_diatrc ) THEN
-         !
-         ! Namelist namc14dia
-         ! -------------------
-         REWIND( numnatb_ref )              ! Namelist namc14dia in reference namelist : c14b diagnostics
-         READ  ( numnatb_ref, namc14dia, IOSTAT = ios, ERR = 903)
-903      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namc14dia in reference namelist', lwp )
-
-         REWIND( numnatb_cfg )              ! Namelist namc14dia in configuration namelist : c14b diagnostics
-         READ  ( numnatb_cfg, namc14dia, IOSTAT = ios, ERR = 904 )
-904      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namc14dia in configuration namelist', lwp )
-         IF(lwm) WRITE ( numonb, namc14dia )
-
-         DO jl = 1, jp_c14b_2d
-            jn = jp_c14b0_2d + jl - 1
-            ctrc2d(jn) = c14dia2d(jl)%sname
-            ctrc2l(jn) = c14dia2d(jl)%lname
-            ctrc2u(jn) = c14dia2d(jl)%units
-         END DO
-
-         DO jl = 1, jp_c14b_3d
-            jn = jp_c14b0_3d + jl - 1
-            ctrc3d(jn) = c14dia3d(jl)%sname
-            ctrc3l(jn) = c14dia3d(jl)%lname
-            ctrc3u(jn) = c14dia3d(jl)%units
-         END DO
-
-         IF(lwp) THEN                   ! control print
-            WRITE(numout,*)
-            WRITE(numout,*) ' Namelist : natadd'
-            DO jl = 1, jp_c14b_3d
-               jn = jp_c14b0_3d + jl - 1
-               WRITE(numout,*) '  3d diag nb : ', jn, '    short name : ', ctrc3d(jn), &
-                 &             '  long name  : ', ctrc3l(jn), '   unit : ', ctrc3u(jn)
-            END DO
-            WRITE(numout,*) ' '
-
-            DO jl = 1, jp_c14b_2d
-               jn = jp_c14b0_2d + jl - 1
-               WRITE(numout,*) '  2d diag nb : ', jn, '    short name : ', ctrc2d(jn), &
-                 &             '  long name  : ', ctrc2l(jn), '   unit : ', ctrc2u(jn)
-            END DO
-            WRITE(numout,*) ' '
-         ENDIF
-         !
-      ENDIF
 
    IF(lwm) CALL FLUSH ( numonb )     ! flush output namelist C14b
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90	(revision 8441)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/CFC/trcnam_cfc.F90	(revision 8442)
@@ -47,8 +47,6 @@
       INTEGER :: ios                 ! Local integer output status for namelist read
       INTEGER :: jl, jn
-      TYPE(DIAG), DIMENSION(jp_cfc_2d) :: cfcdia2d
       !!
       NAMELIST/namcfcdate/ ndate_beg, nyear_res, simu_type 
-      NAMELIST/namcfcdia/  cfcdia2d     ! additional diagnostics
       !!----------------------------------------------------------------------
       !                             ! Open namelist files
@@ -82,37 +80,4 @@
       !
 
-      IF( .NOT.lk_iomput .AND. ln_diatrc ) THEN
-         !
-         ! Namelist namcfcdia
-         ! -------------------
-         REWIND( numnatc_ref )              ! Namelist namcfcdia in reference namelist : CFC diagnostics
-         READ  ( numnatc_ref, namcfcdia, IOSTAT = ios, ERR = 903)
-903      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namcfcdia in reference namelist', lwp )
-
-         REWIND( numnatc_cfg )              ! Namelist namcfcdia in configuration namelist : CFC diagnostics
-         READ  ( numnatc_cfg, namcfcdia, IOSTAT = ios, ERR = 904 )
-904      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namcfcdia in configuration namelist', lwp )
-         IF(lwm) WRITE ( numonc, namcfcdia )
-
-         DO jl = 1, jp_cfc_2d
-            jn = jp_cfc0_2d + jl - 1
-            ctrc2d(jn) = TRIM( cfcdia2d(jl)%sname )
-            ctrc2l(jn) = TRIM( cfcdia2d(jl)%lname )
-            ctrc2u(jn) = TRIM( cfcdia2d(jl)%units )
-         END DO
-
-         IF(lwp) THEN                   ! control print
-            WRITE(numout,*)
-            WRITE(numout,*) ' Namelist : natadd'
-            DO jl = 1, jp_cfc_2d
-               jn = jp_cfc0_2d + jl - 1
-               WRITE(numout,*) '  2d diag nb : ', jn, '    short name : ', ctrc2d(jn), &
-                 &             '  long name  : ', ctrc2l(jn), '   unit : ', ctrc2u(jn)
-            END DO
-            WRITE(numout,*) ' '
-         ENDIF
-         !
-      ENDIF
-
    IF(lwm) CALL FLUSH ( numonc )     ! flush output namelist CFC
 
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 8441)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 8442)
@@ -257,21 +257,10 @@
       !ENDIF                                            
       !
-      IF( lk_iomput ) THEN
-         IF  (iom_use("qtrCFC11"))  CALL iom_put( "qtrCFC11"  , qtr_cfc (:,:,1) )
-         IF  (iom_use("qintCFC11")) CALL iom_put( "qintCFC11" , qint_cfc(:,:,1) )
-         IF  (iom_use("qtrCFC12"))  CALL iom_put( "qtrCFC12"  , qtr_cfc (:,:,2) )
-         IF  (iom_use("qintCFC12")) CALL iom_put( "qintCFC12" , qint_cfc(:,:,2) )
-         IF  (iom_use("qtrSF6"))    CALL iom_put( "qtrSF6"    , qtr_cfc (:,:,3) )
-         IF  (iom_use("qintSF6"))   CALL iom_put( "qintSF6"   , qint_cfc(:,:,3) )
-      ELSE
-         IF( ln_diatrc ) THEN
-            trc2d(:,:,jp_cfc0_2d    ) = qtr_cfc (:,:,1)
-            trc2d(:,:,jp_cfc0_2d + 1) = qint_cfc(:,:,1)
-            trc2d(:,:,jp_cfc0_2d + 2) = qtr_cfc (:,:,2)
-            trc2d(:,:,jp_cfc0_2d + 3) = qint_cfc(:,:,2)
-            trc2d(:,:,jp_cfc0_2d + 4) = qtr_cfc (:,:,3)
-            trc2d(:,:,jp_cfc0_2d + 5) = qint_cfc(:,:,3)
-         END IF
-      END IF
+      IF  (iom_use("qtrCFC11"))  CALL iom_put( "qtrCFC11"  , qtr_cfc (:,:,1) )
+      IF  (iom_use("qintCFC11")) CALL iom_put( "qintCFC11" , qint_cfc(:,:,1) )
+      IF  (iom_use("qtrCFC12"))  CALL iom_put( "qtrCFC12"  , qtr_cfc (:,:,2) )
+      IF  (iom_use("qintCFC12")) CALL iom_put( "qintCFC12" , qint_cfc(:,:,2) )
+      IF  (iom_use("qtrSF6"))    CALL iom_put( "qtrSF6"    , qtr_cfc (:,:,3) )
+      IF  (iom_use("qintSF6"))   CALL iom_put( "qintSF6"   , qint_cfc(:,:,3) )
       !
       IF( l_trdtrc ) THEN
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcsms_idtra.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcsms_idtra.F90	(revision 8441)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcsms_idtra.F90	(revision 8442)
@@ -165,15 +165,7 @@
       !ENDIF
       !
-      IF( lk_iomput ) THEN
          CALL iom_put( "qtrIDTRA"  , qtr_idtra (:,:,1) )
          CALL iom_put( "qintIDTRA" , qint_idtra(:,:,1) )
          CALL iom_put( "invIDTRA" , inv_idtra(:,:,1) )
-      ELSE
-         IF( ln_diatrc ) THEN
-            trc2d(:,:,jp_idtra0_2d    ) = qtr_idtra (:,:,1)
-            trc2d(:,:,jp_idtra0_2d + 1) = qint_idtra(:,:,1)
-            trc2d(:,:,jp_idtra0_2d + 2) = inv_idtra(:,:,1)
-         END IF
-      END IF
       !
 # if defined key_debug_medusa
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/air_sea.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/air_sea.F90	(revision 8441)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/air_sea.F90	(revision 8442)
@@ -124,4 +124,10 @@
       !! Air-sea gas exchange
       !!-----------------------------------------------------------
+
+#   if defined key_debug_medusa
+               IF (lwp) write (numout,*)                     & 
+               'air-sea: gas_transfer kt = ', kt
+               CALL flush(numout)
+#   endif
       DO jj = 2,jpjm1
          DO ji = 2,jpim1
@@ -145,18 +151,15 @@
                !!                 Wanninkhof (2014), option 7
                !!
+               CALL gas_transfer( wndm(ji,jj), 1, 7,         &  ! inputs
+                                  f_kw660(ji,jj) )              ! outputs
+            ENDIF
+         ENDDO
+      ENDDO
+
 #   if defined key_debug_medusa
-               IF (lwp) write (numout,*) 'trc_bio_medusa: entering gas_transfer'
+               IF (lwp) write (numout,*)                     &
+               'air-sea: carb-chem kt = ', kt
                CALL flush(numout)
 #   endif
-               CALL gas_transfer( wndm(ji,jj), 1, 7,         &  ! inputs
-                                  f_kw660(ji,jj) )              ! outputs
-#   if defined key_debug_medusa
-               IF (lwp) write (numout,*) 'trc_bio_medusa: exiting gas_transfer'
-               CALL flush(numout)
-#   endif
-            ENDIF
-         ENDDO
-      ENDDO
-
       DO jj = 2,jpjm1
          DO ji = 2,jpim1
@@ -228,5 +231,5 @@
                !!                 failure position can be determined
                if (iters .eq. 25) then
-                  IF(lwp) WRITE(numout,*) ' trc_bio_medusa: ITERS WARNING, ', &
+                  IF(lwp) WRITE(numout,*) 'air-sea: ITERS WARNING, ',       &
                      iters, ' AT (', ji, ', ', jj, ', 1) AT ', kt
                endif
@@ -335,7 +338,6 @@
                                          hmld(ji,jj),qsr(ji,jj),              &
                                          zdin(ji,jj), dms_nlim(ji,jj),        &
-                                         dms_andr(ji,jj),dms_simo(ji,jj),     &
-                                         dms_aran(ji,jj),dms_hall(ji,jj),     &
-                                         dms_andm(ji,jj))
+                                         dms_andr,dms_simo,dms_aran,dms_hall, & 
+                                         dms_andm)
                   else
                      !! use diel-average inputs
@@ -346,53 +348,49 @@
                                          zn_dms_mld(ji,jj),zn_dms_qsr(ji,jj), &
                                          zn_dms_din(ji,jj),dms_nlim(ji,jj),   &
-                                         dms_andr(ji,jj),dms_simo(ji,jj),     &
-                                         dms_aran(ji,jj),dms_hall(ji,jj),     &
-                                         dms_andm(ji,jj))
+                                         dms_andr,dms_simo,dms_aran,dms_hall, & 
+                                         dms_andm)
                   endif
                   !!
                   !! assign correct output to variable passed to atmosphere
                   if (jdms_model .eq. 1) then
-                     dms_surf(ji,jj) = dms_andr(ji,jj)
+                     dms_surf = dms_andr
                   elseif (jdms_model .eq. 2) then
-                     dms_surf(ji,jj) = dms_simo(ji,jj)
+                     dms_surf = dms_simo
                   elseif (jdms_model .eq. 3) then
-                     dms_surf(ji,jj) = dms_aran(ji,jj)
+                     dms_surf = dms_aran
                   elseif (jdms_model .eq. 4) then
-                     dms_surf(ji,jj) = dms_hall(ji,jj)
+                     dms_surf = dms_hall
                   elseif (jdms_model .eq. 5) then
-                     dms_surf(ji,jj) = dms_andm(ji,jj)
+                     dms_surf = dms_andm
                   endif
                   !!
                   !! 2D diag through iom_use
-                  IF( lk_iomput ) THEN
-                     IF( med_diag%DMS_SURF%dgsave ) THEN
-                        dms_surf2d(ji,jj) = dms_surf(ji,jj)
-                     ENDIF
-                     IF( med_diag%DMS_ANDR%dgsave ) THEN
-                        dms_andr2d(ji,jj) = dms_andr(ji,jj)
-                     ENDIF
-                     IF( med_diag%DMS_SIMO%dgsave ) THEN
-                        dms_simo2d(ji,jj) = dms_simo(ji,jj)
-                     ENDIF
-                     IF( med_diag%DMS_ARAN%dgsave ) THEN
-                        dms_aran2d(ji,jj) = dms_aran(ji,jj)
-                     ENDIF
-                     IF( med_diag%DMS_HALL%dgsave ) THEN
-                        dms_hall2d(ji,jj) = dms_hall(ji,jj)
-                     ENDIF 
-                     IF( med_diag%DMS_ANDM%dgsave ) THEN 
-                        dms_andm2d(ji,jj) = dms_andm(ji,jj) 
-                     ENDIF
-#   if defined key_debug_medusa
-                     IF (lwp) write (numout,*)                                &
-                        'trc_bio_medusa: finish calculating dms'
-                     CALL flush(numout)
-#   endif 
-                  ENDIF      !! End iom
+                  IF( med_diag%DMS_SURF%dgsave ) THEN
+                     dms_surf2d(ji,jj) = dms_surf
+                  ENDIF
+                  IF( med_diag%DMS_ANDR%dgsave ) THEN
+                     dms_andr2d(ji,jj) = dms_andr
+                  ENDIF
+                  IF( med_diag%DMS_SIMO%dgsave ) THEN
+                     dms_simo2d(ji,jj) = dms_simo
+                  ENDIF
+                  IF( med_diag%DMS_ARAN%dgsave ) THEN
+                     dms_aran2d(ji,jj) = dms_aran
+                  ENDIF
+                  IF( med_diag%DMS_HALL%dgsave ) THEN
+                     dms_hall2d(ji,jj) = dms_hall
+                  ENDIF 
+                  IF( med_diag%DMS_ANDM%dgsave ) THEN 
+                     dms_andm2d(ji,jj) = dms_andm
+                  ENDIF
                ENDIF
             ENDDO
          ENDDO
+#   if defined key_debug_medusa
+         IF (lwp) write (numout,*)                                &
+            'air-sea: finish calculating dms kt = ',kt
+            CALL flush(numout)
+#   endif 
       ENDIF                  !! End IF (jdms == 1)
-
 
       !!
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_med_diag_iomput.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_med_diag_iomput.F90	(revision 8441)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_med_diag_iomput.F90	(revision 8442)
@@ -61,5 +61,5 @@
 #   if defined key_debug_medusa
                IF (lwp) write (numout,*)                                     &
-                  'trc_bio_medusa: diag in ij-jj-jk loop'
+                  'bio_med_diag_iomput: in ij-jj loop jk = ', jk
                CALL flush(numout)
 #   endif
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_diag.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_diag.F90	(revision 8441)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_diag.F90	(revision 8442)
@@ -31,5 +31,4 @@
       !!-------------------------------------------------------------------
       USE bio_med_diag_iomput_mod,  ONLY: bio_med_diag_iomput
-      USE bio_med_diag_trc_mod,     ONLY: bio_med_diag_trc
       USE bio_medusa_mod
       USE dom_oce,                  ONLY: e3t_0, e3t_n,                  &
@@ -42,5 +41,5 @@
       USE sms_medusa,               ONLY: xrfn, xthetapd, xthetapn,      &
                                           xthetazme, xthetazmi
-      USE trc,                      ONLY: ln_diatrc, med_diag 
+      USE trc,                      ONLY: med_diag 
 # if defined key_roam
       USE trcoxy_medusa,            ONLY: oxy_sato
@@ -193,19 +192,8 @@
 # endif
 
-      IF( lk_iomput  .AND.  .NOT.  ln_diatrc  ) THEN
-
-         !!---------------------------------------------------------------
-         !! Calculates the diagnostics used with iom_put
-         !!---------------------------------------------------------------
-         CALL bio_med_diag_iomput( jk )
-
-      ELSE IF( ln_diatrc ) THEN
-
-         !!---------------------------------------------------------------
-         !! The diagnostics without using iom_use
-         !!---------------------------------------------------------------
-         CALL bio_med_diag_trc( jk )
-
-      ENDIF
+      !!---------------------------------------------------------------
+      !! Calculates the diagnostics used with iom_put
+      !!---------------------------------------------------------------
+      CALL bio_med_diag_iomput( jk )
 
    END SUBROUTINE bio_medusa_diag
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_diag_slice.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_diag_slice.F90	(revision 8441)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_diag_slice.F90	(revision 8442)
@@ -60,9 +60,10 @@
       !!
       !!-----------------------------------------
-      IF (jk.eq.1) THEN
 #   if defined key_debug_medusa
-         IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 1'
+         IF (lwp) write (numout,*) 'bio_medusa_diag_slice: start jk = ', jk
          CALL flush(numout)
 #   endif
+      !!
+      IF (jk.eq.1) THEN
          !! JPALM -- 02-06-2017 --
          !! add Chl surf coupling
@@ -245,8 +246,4 @@
 # endif                     
       ELSE IF (jk.eq.i0100) THEN 
-#   if defined key_debug_medusa
-         IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 100'
-         CALL flush(numout)
-#   endif
          IF( med_diag%SDT__100%dgsave ) THEN
             zw2d(:,:) = fslownflux(:,:) * tmask(:,:,jk)
@@ -293,15 +290,6 @@
             CALL iom_put( "epSI100"   , ffastsi )
          ENDIF		     
-      ELSE IF (jk.eq.i0150) THEN
-#   if defined key_debug_medusa
-         IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 150'
-         CALL flush(numout)
-#   endif
 # endif                     
       ELSE IF (jk.eq.i0200) THEN
-#   if defined key_debug_medusa
-         IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 200'
-         CALL flush(numout)
-#   endif
          IF( med_diag%SDT__200%dgsave ) THEN
             zw2d(:,:) = fslownflux(:,:) * tmask(:,:,jk)
@@ -333,8 +321,4 @@
 # endif                     
       ELSE IF (jk.eq.i0500) THEN
-#   if defined key_debug_medusa
-         IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 500'
-         CALL flush(numout)
-#   endif
          IF( med_diag%SDT__500%dgsave ) THEN
             zw2d(:,:) = fslownflux(:,:) * tmask(:,:,jk)
@@ -369,8 +353,4 @@
 # endif                      
       ELSE IF (jk.eq.i1000) THEN
-#   if defined key_debug_medusa
-         IF (lwp) write (numout,*) 'trc_bio_medusa: diag jk = 1000'
-         CALL flush(numout)
-#   endif
          IF( med_diag%SDT_1000%dgsave ) THEN
             zw2d(:,:) = fslownflux(:,:) * tmask(:,:,jk)
@@ -420,4 +400,8 @@
       ENDIF		     
 # endif		     
+#   if defined key_debug_medusa
+         IF (lwp) write (numout,*) 'bio_medusa_diag_slice: end jk = ', jk
+         CALL flush(numout)
+#   endif
 
    END SUBROUTINE bio_medusa_diag_slice
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_fin.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_fin.F90	(revision 8441)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_fin.F90	(revision 8442)
@@ -51,7 +51,5 @@
                                    zn_sed_c, zn_sed_ca, zn_sed_fe,      &
                                    zn_sed_n, zn_sed_si
-      USE trc,               ONLY: ctrc2d, ctrc3d, ln_diatrc,           &
-                                   med_diag, nittrc000,                 &
-                                   trbio, trc2d, trc3d
+      USE trc,               ONLY: med_diag, nittrc000 
       USE trcnam_trp,        ONLY: ln_trcadv_cen2, ln_trcadv_tvd
  
@@ -100,23 +98,4 @@
          zn_sed_ca(:,:) = za_sed_ca(:,:)
       endif
-      IF( ln_diatrc ) THEN
-         DO jj = 2,jpjm1
-            DO ji = 2,jpim1
-               trc2d(ji,jj,131) = za_sed_n(ji,jj)
-               trc2d(ji,jj,132) = za_sed_fe(ji,jj)
-               trc2d(ji,jj,133) = za_sed_c(ji,jj)
-               trc2d(ji,jj,134) = za_sed_si(ji,jj)
-               trc2d(ji,jj,135) = za_sed_ca(ji,jj)
-            ENDDO
-         ENDDO
-         !! AXY (07/07/15): temporary hijacking
-# if defined key_roam
-  !!       trc2d(:,:,126) = zn_dms_chn(:,:)
-  !!       trc2d(:,:,127) = zn_dms_chd(:,:)
-  !!       trc2d(:,:,128) = zn_dms_mld(:,:)
-  !!       trc2d(:,:,129) = zn_dms_qsr(:,:)
-  !!       trc2d(:,:,130) = zn_dms_din(:,:)
-# endif
-      ENDIF 
       !!
       if (ibenthic.eq.2) then
@@ -238,5 +217,5 @@
          ENDIF
       endif
-     
+
 #  if defined key_debug_medusa
          !! AXY (12/07/17)
@@ -279,5 +258,5 @@
                ENDIF
             ENDDO
-         ENDDO
+         ENDDO   
          !! silicon
          DO jj = 2,jpjm1
@@ -292,5 +271,5 @@
                ENDIF
             ENDDO
-         ENDDO
+         ENDDO   
          !! carbon
          DO jj = 2,jpjm1
@@ -306,5 +285,5 @@
                ENDIF
             ENDDO
-         ENDDO
+         ENDDO   
          !! alkalinity
          DO jj = 2,jpjm1
@@ -319,176 +298,7 @@
                ENDIF
             ENDDO
-         ENDDO
+         ENDDO   
 #  endif
- 
-      IF( ln_diatrc ) THEN
-         !!-----------------------------------------------------------------
-         !! Output several accumulated diagnostics
-         !!   - biomass-average phytoplankton limitation terms
-         !!   - integrated tendency terms
-         !!-----------------------------------------------------------------
-         !! 
-         DO jj = 2,jpjm1
-            DO ji = 2,jpim1
-               !! non-diatom phytoplankton limitations
-               trc2d(ji,jj,25)  = trc2d(ji,jj,25) / MAX(ftot_pn(ji,jj), rsmall)
-               trc2d(ji,jj,26)  = trc2d(ji,jj,26) / MAX(ftot_pn(ji,jj), rsmall)
-               trc2d(ji,jj,27)  = trc2d(ji,jj,27) / MAX(ftot_pn(ji,jj), rsmall)
-               !! diatom phytoplankton limitations
-               trc2d(ji,jj,28)  = trc2d(ji,jj,28) / MAX(ftot_pd(ji,jj), rsmall)
-               trc2d(ji,jj,29)  = trc2d(ji,jj,29) / MAX(ftot_pd(ji,jj), rsmall)
-               trc2d(ji,jj,30)  = trc2d(ji,jj,30) / MAX(ftot_pd(ji,jj), rsmall)
-               trc2d(ji,jj,31)  = trc2d(ji,jj,31) / MAX(ftot_pd(ji,jj), rsmall)
-               trc2d(ji,jj,32)  = trc2d(ji,jj,32) / MAX(ftot_pd(ji,jj), rsmall)
-               !! tendency terms
-               trc2d(ji,jj,76)  = fflx_n(ji,jj)
-               trc2d(ji,jj,77)  = fflx_si(ji,jj)
-               trc2d(ji,jj,78)  = fflx_fe(ji,jj)
-               !! Integrated biomass.
-               !! integrated non-diatom phytoplankton
-               trc2d(ji,jj,79)  = ftot_pn(ji,jj)
-               !! integrated diatom phytoplankton
-               trc2d(ji,jj,80)  = ftot_pd(ji,jj)
-               !! Integrated microzooplankton
-               trc2d(ji,jj,217) = ftot_zmi(ji,jj)
-               !! Integrated mesozooplankton
-               trc2d(ji,jj,218) = ftot_zme(ji,jj)
-               !! Integrated slow detritus, nitrogen
-               trc2d(ji,jj,219) = ftot_det(ji,jj)
-               !! Integrated slow detritus, carbon
-               trc2d(ji,jj,220) = ftot_dtc(ji,jj)
-# if defined key_roam
-               !! The balance of nitrogen production/consumption.
-               !! integrated nitrogen production
-               trc2d(ji,jj,111) = fnit_prod(ji,jj)
-               !! integrated nitrogen consumption
-               trc2d(ji,jj,112) = fnit_cons(ji,jj)
-               !! The balance of carbon production/consumption.
-               !! integrated carbon production
-               trc2d(ji,jj,113) = fcar_prod(ji,jj)
-               !! integrated carbon consumption
-               trc2d(ji,jj,114) = fcar_cons(ji,jj)
-               !! The balance of oxygen production/consumption.
-               !! integrated oxygen production
-               trc2d(ji,jj,115) = foxy_prod(ji,jj)
-               !! integrated oxygen consumption
-               trc2d(ji,jj,116) = foxy_cons(ji,jj)
-               !! integrated unrealised oxygen consumption
-               trc2d(ji,jj,117) = foxy_anox(ji,jj)
-# endif
-            ENDDO
-         ENDDO
-         
-# if defined key_roam
-#  if defined key_axy_nancheck
-         !!---------------------------------------------------------------
-         !! Check for NaNs in diagnostic outputs
-         !!---------------------------------------------------------------
-         !! 
-         !! 2D diagnostics
-         DO jn = 1,150
-            fq0 = SUM(trc2d(:,:,jn))
-            !! AXY (30/01/14): "isnan" problem on HECTOR
-            !! if (fq0 /= fq0 ) then
-            if ( ieee_is_nan( fq0 ) ) then
-               !! there's a NaN here
-               if (lwp) write(numout,*)                                     &
-                  'NAN detected in 2D diagnostic field', jn, 'at time',     &
-                   kt, 'at position:'
-               DO jj = 1,jpj
-                  DO ji = 1,jpi
-                     if ( ieee_is_nan( trc2d(ji,jj,jn) ) ) then
-                        if (lwp) write (numout,'(a,3i6)') 'NAN-CHECK',      &
-                                 ji, jj, jn
-                     endif
-                  ENDDO
-               ENDDO
-	       CALL ctl_stop( 'trcbio_medusa, NAN in 2D diagnostic field' )
-            endif
-         ENDDO
-         !!
-         !! 3D diagnostics
-         DO jn = 1,5
-            fq0 = SUM(trc3d(:,:,:,jn))
-            !! AXY (30/01/14): "isnan" problem on HECTOR
-            !! if (fq0 /= fq0 ) then
-            if ( ieee_is_nan( fq0 ) ) then
-               !! there's a NaN here
-               if (lwp) write(numout,*)                                     &
-                  'NAN detected in 3D diagnostic field', jn, 'at time',     &
-                  kt, 'at position:'
-               DO jk = 1,jpk
-                  DO jj = 1,jpj
-                     DO ji = 1,jpi
-                        if ( ieee_is_nan( trc3d(ji,jj,jk,jn) ) ) then
-                           if (lwp) write (numout,'(a,4i6)') 'NAN-CHECK',   &
-                                    ji, jj, jk, jn
-                        endif
-                     ENDDO
-                  ENDDO
-               ENDDO
-	       CALL ctl_stop( 'trcbio_medusa, NAN in 3D diagnostic field' )
-            endif
-         ENDDO
-	 CALL flush(numout)
-#  endif
-# endif
-
-         !!----------------------------------------------------------------
-         !! Don't know what this does; belongs to someone else ...
-         !!----------------------------------------------------------------
-         !! 
-         !! Lateral boundary conditions on trc2d
-         DO jn=1,jp_medusa_2d
-             CALL lbc_lnk(trc2d(:,:,jn),'T',1. )
-         ENDDO 
-
-         !! Lateral boundary conditions on trc3d
-         DO jn=1,jp_medusa_3d
-             CALL lbc_lnk(trc3d(:,:,1,jn),'T',1. )
-         ENDDO 
-
-
-# if defined key_axy_nodiag
-         !!----------------------------------------------------------------
-         !! Blank diagnostics as a NaN-trap
-         !!----------------------------------------------------------------
-         !! 
-         !! blank 2D diagnostic array
-         trc2d(:,:,:) = 0.e0
-         !!
-         !! blank 3D diagnostic array
-         trc3d(:,:,:,:) = 0.e0
-# endif
-
-
-         !!----------------------------------------------------------------
-         !! Add in XML diagnostics stuff
-         !!----------------------------------------------------------------
-         !!
-         !! ** 2D diagnostics
-         DO jn=1,jp_medusa_2d
-            CALL iom_put(TRIM(ctrc2d(jn)), trc2d(:,:,jn))
-         END DO
-!! AXY (17/02/14): don't think I need this if I modify the above for 
-!! all diagnostics
-!! #  if defined key_roam
-!!          DO jn=91,jp_medusa_2d
-!!             CALL iom_put(TRIM(ctrc2d(jn)), trc2d(:,:,jn))
-!!          END DO      
-!! #  endif
-         !!
-         !! ** 3D diagnostics
-         DO jn=1,jp_medusa_3d
-            CALL iom_put(TRIM(ctrc3d(jn)), trc3d(:,:,:,jn))
-         END DO
-!! AXY (17/02/14): don't think I need this if I modify the above for 
-!! all diagnostics
-!! #  if defined key_roam
-!!          CALL iom_put(TRIM(ctrc3d(5)), trc3d(:,:,:,5))
-!! #  endif
-
-
-      ELSE IF( lk_iomput .AND. .NOT. ln_diatrc ) THEN
+
          !!!---------------------------------------------------------------
          !! Add very last diag calculations 
@@ -529,5 +339,5 @@
          !! ** 2D diagnostics
 #   if defined key_debug_medusa
-         IF (lwp) write (numout,*) 'trc_bio_medusa: export all diag.'
+         IF (lwp) write (numout,*) 'bio_medusa_fin: export all diag kt = ', kt
          CALL flush(numout)
 #   endif
@@ -1181,6 +991,4 @@
           DEALLOCATE( zw2d )
 
-       ENDIF                    ! end of ln_diatrc option
-
    END SUBROUTINE bio_medusa_fin
 
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_init.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_init.F90	(revision 8441)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/TOP_SRC/MEDUSA/bio_medusa_init.F90	(revision 8442)
@@ -35,6 +35,6 @@
       USE par_oce,           ONLY: jpi, jpj, jpk
       USE sms_medusa,        ONLY: jdms
-      USE trc,               ONLY: ln_diatrc, med_diag, nittrc000,     &
-                                   trc2d, trc3d
+      USE trc,               ONLY: ln_diatrc, med_diag, nittrc000 
+      USE in_out_manager,    ONLY: lwp
 
 # if defined key_iomput
@@ -47,9 +47,6 @@
 
       IF( ln_diatrc ) THEN
-         !! blank 2D diagnostic array
-         trc2d(:,:,:) = 0.e0
-         !!
-         !! blank 3D diagnostic array
-         trc3d(:,:,:,:) = 0.e0
+         IF (lwp) write (numout,*) 'Diagnostics are now ALL through XIOS (key_xios)'
+         IF (lwp) write (numout,*) 'No more key_diatrc anymore.'
       ENDIF
 
@@ -171,5 +168,5 @@
       !! -----------------------------
       !! Juju :: add kt condition !!
-      IF ( lk_iomput .AND. .NOT.  ln_diatrc ) THEN 
+      IF ( lk_iomput ) THEN 
 
          !! initialise iom_use test
